﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SelectionChangedICommandBiding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new MainViewModel();
        }
    }

    class MainViewModel
    {
        public ObservableCollection<Company> Companies { get; set; }

        public MainViewModel()
        {
            Companies = new ObservableCollection<Company>();
            Companies.Add(new Company()
            {
                ID = 1,
                Name = "IG"
            });
            Companies.Add(new Company()
            {
                ID = 2,
                Name = "IF"
            });
            Companies.Add(new Company()
            {
                ID = 3,
                Name = "ANG"
            });
            Companies.Add(new Company()
            {
                ID = 4,
                Name = "ALN"
            });
            Companies.Add(new Company()
            {
                ID = 5,
                Name = "DKS"
            });
        }

        public ICommand SelectionChanged
        {
            get
            {
                return new RelayCommand<object>(
                    new Action<object>(
                        
                        (obj) =>
                        {
                            MessageBox.Show("Some Test");
                        }
                        ));
            }
        }
    }

    public class RelayCommand<T> : ICommand
    {

        #region Declarations

        readonly Predicate<T> _canExecute;
        readonly Action<T> _execute;

        #endregion

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="RelayCommand&lt;T&gt;"/> class and the command can always be executed.
        /// </summary>
        /// <param name="execute">The execution logic.</param>
        public RelayCommand(Action<T> execute)
            : this(execute, null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RelayCommand&lt;T&gt;"/> class.
        /// </summary>
        /// <param name="execute">The execution logic.</param>
        /// <param name="canExecute">The execution status logic.</param>
        public RelayCommand(Action<T> execute, Predicate<T> canExecute)
        {

            if (execute == null)
                throw new ArgumentNullException("execute");
            _execute = execute;
            _canExecute = canExecute;
        }

        #endregion

        #region ICommand Members

        public event EventHandler CanExecuteChanged
        {
            add
            {

                if (_canExecute != null)
                    CommandManager.RequerySuggested += value;
            }
            remove
            {

                if (_canExecute != null)
                    CommandManager.RequerySuggested -= value;
            }
        }

      
        public virtual Boolean CanExecute(Object parameter)
        {
            return _canExecute == null ? true : _canExecute((T)parameter);
        }

        public virtual void Execute(Object parameter)
        {
            _execute((T)parameter);
        }

        #endregion
    }


    class Company
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }

 
}
